<template>
  <v-container>
    <v-layout row v-if="loading">
      <v-flex xs12 class="text-xs-center">
        <v-progress-circular
          indeterminate
          class="primary--text"
          :width="7"
          :size="70"
          ></v-progress-circular>
      </v-flex>
    </v-layout>
    <v-layout row wrap v-else>
      <v-flex xs12>
        <v-card>
          <v-card-title>
            <h6 class="primary--text">{{ meetup.title }}</h6>
            <template v-if="userIsCreator">
              <v-spacer></v-spacer>
              <app-edit-meetup-details-dialog
                :meetup="meetup"></app-edit-meetup-details-dialog>
            </template>
          </v-card-title>
          <v-card-media
            :src="meetup.imageUrl"
            height="400px"
            >
          </v-card-media>
          <v-card-text>
            <div class="info--text">
              {{ meetup.date | date }} - {{ meetup.location }}
            </div>
            <app-edit-meetup-date-dialog
              :meetup="meetup"
              v-if="userIsCreator"></app-edit-meetup-date-dialog>
            <app-edit-meetup-time-dialog
              :meetup="meetup"
              v-if="userIsCreator"></app-edit-meetup-time-dialog>
            <div>{{ meetup.description }}</div>
          </v-card-text>
          <v-card-actions>
            <v-btn
              dark
              class="primary"
              v-if="userIsAuthenticated && userIsCreator"
              @click="onDelete"
              >DELETE</v-btn>
            <v-spacer></v-spacer>
            <app-meetup-register-dialog
              :meetupId="meetup.id"
              v-if="userIsAuthenticated && !userIsCreator"
              ></app-meetup-register-dialog>
          </v-card-actions>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
export default {
  props: ['id'],
  computed: {
    meetup () {
      return this.$store.getters.loadedMeetup(this.id)
    },
    loading () {
      return this.$store.getters.loading
    },
    userIsAuthenticated () {
      return this.$store.getters.user !== null && this.$store.getters.user !== undefined
    },
    userIsCreator () {
      if (!this.userIsAuthenticated) {
        return false
      }
      return this.$store.getters.user.id === this.meetup.creatorId
    }
  },
  methods: {
    onDelete () {
      if (!this.userIsCreator) {
        return
      }
      this.$store.dispatch('deleteMeetup', this.meetup)
      this.$router.push('/meetups')
    }
  }
}
</script>
